Function Highscore()
	SetColor 255, 255, 255
	
	SetImageFont TitleFont
	DrawText "HIGHSCORE", -2, 0
	
	SetImageFont SmallFont
	Local i:Int
	For i = 1 To 9
		DrawText i+". "+ HighscoreNames[i-1], 10, 45+i*20
		DrawText HighscorePoints[i-1], 250, 45+i*20
	Next
	
	SetImageFont Font
	BackButton.Draw()
	
	If MouseHit(1) Then
		If BackButton.MouseOver() Then
			GAMEMANAGER = GAME_MENU
		EndIf
	EndIf
	
	CastParticles(MouseX(), MouseY(), 1, Rand(1,2), 10, 200+Rand(55), Rand(100), 0)
End Function

Function ReadHighscore()
	Local Stream:TStream
	Local i:Int
	Local iPoints:Int
	
	HighscoreNames = New String [10]
	HighscorePoints = New Int[10]
	
	Stream = ReadStream("Highscore.dat")
	
	If Not Stream Then
		Stream = WriteStream("Highscore.dat")
		For i = 0 Until 9
			iPoints = 50-i*5
			WriteLine(Stream, "NOBODY")
			WriteInt(Stream, iPoints)
			HighscoreNames[i] = ("NOBODY")
			HighscorePoints[i] = iPoints
		Next
		CloseStream Stream
	Else
		For i = 0 Until 9
			HighscoreNames[i] = ReadLine(Stream)
			HighscorePoints[i] = ReadInt(Stream)
		Next
	EndIf
End Function

Function CheckHighscore(iPoints:Int)
	Local i:Int
	For i = 0 Until 9
		If Not NewHighscore Then
			If iPoints > HighscorePoints[i] Then
				NewHighscore = True
			EndIf
		EndIf
	Next
End Function

Function LogHighscore(iName:String, iPoints:Int)
	Local i:Int
	Local iPoints2:Int
	Local iName2:String
	NewHighscore = False
	For i = 0 Until 9
		If Not NewHighscore Then
			If iPoints > HighscorePoints[i] Then
				NewHighscore = True
				iPoints2 = HighscorePoints[i]
				iName2 = HighscoreNames[i]
				HighscorePoints[i] = iPoints
				HighscoreNames[i] = iName
				iPoints = iPoints2
				iName = iName2
			EndIf
		Else
			iPoints2 = HighscorePoints[i]
			iName2 = HighscoreNames[i]
			HighscorePoints[i] = iPoints
			HighscoreNames[i] = iName
			iPoints = iPoints2
			iName = iName2
		EndIf
	Next
	NewHighscore = False
	SaveHighscore()
End Function

Function SaveHighscore()
	Local i:Int
	Local Stream:TStream
	
	Stream = WriteStream("Highscore.dat")
	For i = 0 Until 9
		WriteLine(Stream, HighscoreNames[i])
		WriteInt(Stream, HighscorePoints[i])
	Next
	CloseStream Stream
End Function
