Type TParticle
	Field Lifetime:Int
	Field x:Float, y:Float
	Field xs:Float, ys:Float
	Field red:Byte, green:Byte, blue:Byte
	
	Method Update()
		Lifetime :- 1
		
		If Lifetime <= 0 Then Particles.Remove(Self)
		
		x :+ xs
		y :+ ys
	End Method
	
	Method Draw()
		SetColor red, green, blue
		DrawImage ParticleImage, x, y
	End Method
End Type


Function CastParticles(ix:Int, iy:Int, iCount:Int, iMaxSpeed:Float, iLifetime:Int, ired:Byte=255, igreen:Byte=255, iblue:Byte=255)
	Local i:Int
	Local r:Int
	Local P:TParticle
	
	For i = 0 To iCount
		P = New TParticle
		P.x = ix
		P.y = iy
		r = Rand(0, 360)
		P.xs = Rand(iMaxSpeed)*Sin(r)
		P.ys = Rand(iMaxSpeed)*Cos(r)
		P.Lifetime = Rand(iLifetime)
		
		P.red = ired
		P.green = igreen
		P.blue = iblue
		
		Particles.addlast(P)
	Next
End Function

Function UpdateParticles()
	Local P:TParticle
	For P = EachIn Particles
		P.Update()
	Next
End Function

Function DrawParticles()
	Local P:TParticle
	For P = EachIn Particles
		P.Draw()
	Next
End Function