Function Game()
	Control()
	
	UpdateArrow()
	UpdateTimes()
	
	DrawArrow()
	DrawHUD()
End Function

Function NewRound()
	CoolDownMin = 2000
	CoolDownMax = 3000
	Cooldown = MilliSecs()+6000
	Direction = -1
	Time = 10999
	Start = 0
	Points = 0
	MissClicks = 0
	FastestHit = 999999
	BonusTime = 0
	Fade = 0
	Fade2 = 0
	
	NewHighscore = False
End Function

Function Control()
	If KeyHit(KEY_Left) Then
		ArrowCheck(0)
	ElseIf KeyHit(KEY_Right) Then
		ArrowCheck(1)
	ElseIf KeyHit(KEY_Up) Then
		ArrowCheck(2)
	ElseIf KeyHit(KEY_Down) Then
		ArrowCheck(3)
	EndIf
End Function

Function ArrowCheck(iDirection:Int)
	If start>0 Then
		reward = 0
		If Direction = iDirection Then
			Points :+ 1
			
			If(ReactTime<FastestHit) Then FastestHit = ReactTime
			
			If(ReactTime<350) Then reward = 500
			If(ReactTime<300) Then reward = 1000
			If(ReactTime<250) Then reward = 2000
			If(ReactTime<200) Then reward = 3000
			If(ReactTime<150) Then reward = 5000
			If(ReactTime<100) Then reward = 10000
			
			If reward > 0 Then time :+ reward+ReactTime
			BonusTime:+reward
			
			If iDirection = 0 Then CastParticles(150, 150, 15, Rand(1, 5), 25, 255, 0, 0)
			If iDirection = 1 Then CastParticles(150, 150, 15, Rand(1, 5), 25, 255, 255, 0)
			If iDirection = 2 Then CastParticles(150, 150, 15, Rand(1, 5), 25, 0, 255, 0)
			If iDirection = 3 Then CastParticles(150, 150, 15, Rand(1, 5), 25, 125, 175, 255)
		Else
			MissClicks :+ 1
			Time :-1000
			Fade2 = 255
		EndIf
		Direction = -1
		Cooldown = MilliSecs()+Rand(CoolDownMin, CoolDownMax)
	EndIf
End Function

Function UpdateTimes()
	If MilliSecs()>OldMillisecs Then
		If Direction > -1 Then ReactTime :+ MilliSecs()-OldMillisecs
		If Direction > -1 Then Time :- MilliSecs()-OldMillisecs
		OldMillisecs = MilliSecs()
	EndIf
	
	If Time < 1000 Then
		CheckHighscore(Points)
		Fade = 255
		GAMEMANAGER = GAME_GAMEOVER
	EndIf
End Function

Function UpdateArrow()
	If Cooldown<MilliSecs() And Direction = -1 Then 
		Direction = Rand(0,3)
		ReactTime = 0
		If CoolDownMin>=1000 Then CoolDownMin :- 50
		If CoolDownMax>=2000 Then CoolDownMax :- 25
		If CoolDownMin>=500 Then CoolDownMin :-25
		If CoolDownMax>=1000 Then CoolDownMax :-12
		If CoolDownMin>=250 Then CoolDownMin :- 12
		If CoolDownMax>=750 Then CoolDownmax :- 5
		If CoolDownMin>=5 Then CoolDownMin :- 5
		If CoolDownMax>=10 Then CoolDownMax :- 2
	EndIf
End Function

Function DrawArrow()
	SetColor 255, 255, 255
	If Direction >= 0 Then DrawImage ArrowImage, 150, 150, Direction
End Function

Function DrawHUD()
	Local iTime:Int
	iTime = Ceil(Time/1000)
	
	If start = 0 Then
		SetImageFont TitleFont
		Local iTxt:String
		If CoolDown-MilliSecs() > 4000  Then
			iTxt = "Ready?"
		ElseIf CoolDown-MilliSecs() > 3000 Then
			iTxt = "GO!"
		Else
			CoolDown = MilliSecs()+Rand(3000)
			start = 1
			FlushKeys()
		EndIf
		DrawText iTxt, 150-TextWidth(iTxt)/2, 150-TextHeight(iTxt)/2
		SetImageFont Font
	EndIf
	
	If(iTime>=10) Then 
		DrawText "00:"+iTime, 0, 0
	Else
		If(iTime<=5) Then SetColor 255, 255*Sin(MilliSecs()), 255*Sin(MilliSecs())
		DrawText "00:0"+iTime, 0, 0
	EndIf
				
	If Direction>-1 Then
		SetColor 255, 0, 0
		DrawText "-"+ReactTime+"ms",0 ,25
		Fade = 255
	Else
		If Fade>0 Then Fade:-5
		If reward = 0 Then
			SetColor Fade, 0, 0
			DrawText "-"+ReactTime+"ms", 0, 25
		Else
			SetColor 0, Fade, 0
			If reward = 500 Then DrawText "+"+reward+" (<350ms)", 0, 25
			If reward = 1000 Then DrawText "+"+reward+" (GUT <300ms)", 0, 25
			If reward = 2000 Then DrawText "+"+reward+" (WOW <250ms)", 0, 25
			If reward = 3000 Then DrawText "+"+reward+" (OMG <200ms)", 0, 25
			If reward = 5000 Then DrawText "+"+reward+" (WTF <150ms)", 0, 25
			If reward = 10000 Then DrawText "+"+reward+" (GODLIKE <100ms)", 0, 25
		EndIf
	EndIf
			
	If Fade2>0 Then
		Fade2:-5
		SetColor Fade2, 0, 0
		DrawText "-00:01", 0, 50
	EndIf
End Function
