SuperStrict

Include "includes\game.bmx"
Include "includes\MainMenu.bmx"
Include "includes\GameOver.bmx"
Include "includes\Highscore.bmx"

Include "includes\Types\TButton.bmx"
Include "includes\Types\TParticle.bmx"
'================================================================================================================================================================
'================================================================================================================================================================
'================================================================ VARIABLES =====================================================================================
'================================================================================================================================================================
AppTitle = "BCC#67"

'Timer
Global Timer:TTimer

'Images
Global ArrowImage:TImage
Global ParticleImage:TImage
Global Font:TImageFont
Global SmallFont:TimageFont
Global TitleFont:TImageFont

'Lists
Global Particles:TList

'Gamemanager variables
Global GAMEMANAGER:Byte = 0

Const GAME_MENU:Byte = 0
Const GAME_GAME:Byte = 1
Const GAME_GAMEOVER:Byte = 2
Const GAME_HIGHSCORE:Byte = 3
Const GAME_SHUTDOWN:Byte = 4

'Menu variables
Global SinglePlayerButton:TButton
Global MultiPlayerButton:TButton
Global HighscoreButton:TButton
Global EndButton:TButton

Global HighscoreButton2:TButton
Global BackButton:TButton

'Game variables
Global Start:Byte

Global Name:String

Global Direction:Int

Global CoolDown:Int
Global CoolDownMin:Int
Global CoolDownMax:Int

Global Time:Int
Global ReactTime:Int
Global reward:Int
Global bonusTime:Int
Global FastestHit:Int

Global MissClicks:Int
Global Points:Int

'Highscore variables
Global NewHighscore:Byte
Global HighscoreNames:String[]
Global HighscorePoints:Int[]

'Helping stuff
Global Fade:Byte
Global Fade2:Byte
Global OldMillisecs:Int

'================================================================================================================================================================
'================================================================================================================================================================
'=================================================================== GAME =======================================================================================
'================================================================================================================================================================

'Loading images, creating the timer etc.
InitGame()

'Mainloop
Repeat
	Cls
	UpdateParticles()
	DrawParticles()
	Select GAMEMANAGER
		Case GAME_MENU
			MainMenu()
		Case GAME_GAME
			Game()
		Case GAME_GAMEOVER
			GameOver()
		Case GAME_HIGHSCORE
			Highscore()
	End Select
	Flip 0
	WaitTimer(Timer)
Until KeyHit(KEY_Escape) Or AppTerminate() Or GAMEMANAGER = GAME_SHUTDOWN

End


'================================================================================================================================================================
'================================================================================================================================================================
'================================================================ FUNCTIONS =====================================================================================
'================================================================================================================================================================

Function InitGame()
	Timer = CreateTimer(60)
	
	SeedRnd(MilliSecs())
	
	Particles = New TList
	
	AutoMidHandle(1)
	ArrowImage = LoadAnimImage("gfx\Arrow2.png", 100, 100, 0, 4)
	ParticleImage = LoadImage("gfx\Particle.png")
	
	Font = LoadImageFont("font\comic.ttf", 25)
	SmallFont = LoadImageFont("font\comic.ttf", 15)
	TitleFont = LoadImageFont("font\comic.ttf", 50)
	
	ReadHighscore()
	
	Graphics 300, 300
	
	InitMenu()
	
	SetBlend ALPHABLEND
	SetImageFont Font
End Function

Function InitMenu()
	SinglePlayerButton = CreateButton("SINGLEPLAYER", 10, 100)
	MultiPlayerButton = CreateButton("MULTIPLAYER", 10, 150)
	HighscoreButton = CreateButton("HIGHSCORE", 10, 200)
	EndButton = CreateButton("EXIT", 10, 250)
	
	HighscoreButton2 = CreateButton("HIGHSCORE", 10, 250)
	BackButton = CreateButton("BACK", 10, 250)
End Function